using System;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Services.Exceptions;

using YourCompany.DNNConnect.Components;

namespace YourCompany.Modules.DNNConnect
{
    public partial class Settings : ModuleSettingsBase
    {

        /// <summary>
        /// handles the loading of the module setting for this
        /// control
        /// </summary>
        public override void LoadSettings()
        {
            try
            {
                if (!IsPostBack)
                {
                    DNNConnectSettings settingsData = new DNNConnectSettings(this.TabModuleId);

                    if (settingsData.Template != null)
                    {
                        txtTemplate.Text = settingsData.Template;
                    }
                }
            }
            catch (Exception ex)
            {
                Exceptions.ProcessModuleLoadException(this, ex);
            }
        }

        /// <summary>
        /// handles updating the module settings for this control
        /// </summary>
        public override void UpdateSettings()
        {
            try
            {
                DNNConnectSettings settingsData = new DNNConnectSettings(this.TabModuleId);
                settingsData.Template = txtTemplate.Text;
            }
            catch (Exception ex)
            {
                Exceptions.ProcessModuleLoadException(this, ex);
            }
        }
    }
}